diff -r e32ff462bf6e trytond/modules/account_invoice/invoice.py
--- a/trytond/modules/account_invoice/invoice.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -657,20 +605,21 @@
                 invoice_val + invoice_val + [str(clause[2])])
         return [('id', 'in', [x[0] for x in cursor.fetchall()])]
 
-    def search_untaxed_amount(self, name, clause):
+    @classmethod
+    def search_untaxed_amount(cls, name, clause):
         pool = Pool()
-        rule_obj = pool.get('ir.rule')
-        line_obj = pool.get('account.invoice.line')
-        type_name = FIELDS[self.untaxed_amount._type].sql_type(
-                self.untaxed_amount)[0]
+        Rule = pool.get('ir.rule')
+        Line = pool.get('account.invoice.line')
+        type_name = FIELDS[cls.untaxed_amount._type].sql_type(
+                cls.untaxed_amount)[0]
         cursor = Transaction().cursor
 
-        invoice_query, invoice_val = rule_obj.domain_get('account.invoice')
+        invoice_query, invoice_val = Rule.domain_get('account.invoice')
 
-        cursor.execute('SELECT invoice FROM "' + line_obj._table + '" '
-                'JOIN "' + self._table + '" ON '
-                    '("' + self._table + '".id = '
-                        '"' + line_obj._table + '".invoice) '
+        cursor.execute('SELECT invoice FROM "' + Line._table + '" '
+                'JOIN "' + cls._table + '" ON '
+                    '("' + cls._table + '".id = '
+                        '"' + Line._table + '".invoice) '
                 'WHERE ' + invoice_query + ' '
                 'GROUP BY invoice '
                 'HAVING (CAST(COALESCE(SUM(quantity * unit_price), 0) '
@@ -678,20 +627,21 @@
                 invoice_val + [str(clause[2])])
         return [('id', 'in', [x[0] for x in cursor.fetchall()])]
 
-    def search_tax_amount(self, name, clause):
+    @classmethod
+    def search_tax_amount(cls, name, clause):
         pool = Pool()
-        rule_obj = pool.get('ir.rule')
-        tax_obj = pool.get('account.invoice.tax')
-        type_name = FIELDS[self.tax_amount._type].sql_type(
-                self.tax_amount)[0]
+        Rule = pool.get('ir.rule')
+        Tax = pool.get('account.invoice.tax')
+        type_name = FIELDS[cls.tax_amount._type].sql_type(
+                cls.tax_amount)[0]
         cursor = Transaction().cursor
 
-        invoice_query, invoice_val = rule_obj.domain_get('account.invoice')
+        invoice_query, invoice_val = Rule.domain_get('account.invoice')
 
-        cursor.execute('SELECT invoice FROM "' + tax_obj._table + '" '
-                'JOIN "' + self._table + '" ON '
-                    '("' + self._table + '".id = '
-                        '"' + tax_obj._table + '".invoice) '
+        cursor.execute('SELECT invoice FROM "' + Tax._table + '" '
+                'JOIN "' + cls._table + '" ON '
+                    '("' + cls._table + '".id = '
+                        '"' + Tax._table + '".invoice) '
                 'WHERE ' + invoice_query + ' '
                 'GROUP BY invoice '
                 'HAVING (CAST(COALESCE(SUM(amount), 0) '
@@ -699,62 +649,61 @@
                 invoice_val + [str(clause[2])])
         return [('id', 'in', [x[0] for x in cursor.fetchall()])]
 
-    def get_tax_context(self, invoice):
-        party_obj = Pool().get('party.party')
-        res = {}
-        if isinstance(invoice, dict):
-            if invoice.get('party'):
-                party = party_obj.browse(invoice['party'])
-                if party.lang:
-                    res['language'] = party.lang.code
-        else:
-            if invoice.party.lang:
-                res['language'] = invoice.party.lang.code
-        return res
+    def get_tax_context(self):
+        context = {}
+        if self.party and self.party.lang:
+            context['language'] = self.party.lang.code
+        return context
 
-    def _compute_tax(self, tax, invoice_type):
+    @staticmethod
+    def _compute_tax(invoice_tax, invoice_type):
         val = {}
+        tax = invoice_tax['tax']
         val['manual'] = False
-        val['description'] = tax['tax'].description
-        val['base'] = tax['base']
-        val['amount'] = tax['amount']
-        val['tax'] = tax['tax'].id
+        val['description'] = tax.description
+        val['base'] = invoice_tax['base']
+        val['amount'] = invoice_tax['amount']
+        val['tax'] = tax.id if tax else None
 
         if invoice_type in ('out_invoice', 'in_invoice'):
-            val['base_code'] = tax['tax'].invoice_base_code.id
-            val['base_sign'] = tax['tax'].invoice_base_sign
-            val['tax_code'] = tax['tax'].invoice_tax_code.id
-            val['tax_sign'] = tax['tax'].invoice_tax_sign
-            val['account'] = tax['tax'].invoice_account.id
+            val['base_code'] = (tax.invoice_base_code.id
+                if tax.invoice_base_code else None)
+            val['base_sign'] = tax.invoice_base_sign
+            val['tax_code'] = (tax.invoice_tax_code.id
+                if tax.invoice_tax_code else None)
+            val['tax_sign'] = tax.invoice_tax_sign
+            val['account'] = (tax.invoice_account.id
+                if tax.invoice_account else None)
         else:
-            val['base_code'] = tax['tax'].credit_note_base_code.id
-            val['base_sign'] = tax['tax'].credit_note_base_sign
-            val['tax_code'] = tax['tax'].credit_note_tax_code.id
-            val['tax_sign'] = tax['tax'].credit_note_tax_sign
-            val['account'] = tax['tax'].credit_note_account.id
+            val['base_code'] = (tax.credit_note_base_code.id
+                if tax.credit_note_base_code else None)
+            val['base_sign'] = tax.credit_note_base_sign
+            val['tax_code'] = (tax.credit_note_tax_code.id
+                if tax.credit_note_tax_code else None)
+            val['tax_sign'] = tax.credit_note_tax_sign
+            val['account'] = (tax.credit_note_account.id
+                if tax.credit_note_account else None)
         key = (val['base_code'], val['base_sign'],
                 val['tax_code'], val['tax_sign'],
                 val['account'], val['tax'])
         return key, val
 
-    def _compute_taxes(self, invoice):
-        tax_obj = Pool().get('account.tax')
-        currency_obj = Pool().get('currency.currency')
+    def _compute_taxes(self):
+        Tax = Pool().get('account.tax')
 
-        context = self.get_tax_context(invoice)
+        context = self.get_tax_context()
 
         res = {}
-        for line in invoice.lines:
+        for line in self.lines:
             # Don't round on each line to handle rounding error
             if line.type != 'line':
                 continue
-            tax_ids = [x.id for x in line.taxes]
             with Transaction().set_context(**context):
-                taxes = tax_obj.compute(tax_ids, line.unit_price,
+                taxes = Tax.compute(line.taxes, line.unit_price,
                         line.quantity)
             for tax in taxes:
-                key, val = self._compute_tax(tax, invoice.type)
-                val['invoice'] = invoice.id
+                key, val = self._compute_tax(tax, self.type)
+                val['invoice'] = self.id
                 if not key in res:
                     res[key] = val
                 else:
@@ -762,82 +711,81 @@
                     res[key]['amount'] += val['amount']
         for key in res:
             for field in ('base', 'amount'):
-                res[key][field] = currency_obj.round(invoice.currency,
-                        res[key][field])
+                res[key][field] = self.currency.round(res[key][field])
         return res
 
-    def update_taxes(self, ids, exception=False):
-        tax_obj = Pool().get('account.invoice.tax')
-        currency_obj = Pool().get('currency.currency')
-        for invoice in self.browse(ids):
+    @classmethod
+    def update_taxes(cls, invoices, exception=False):
+        Tax = Pool().get('account.invoice.tax')
+        for invoice in invoices:
             if invoice.state in ('open', 'paid', 'cancel'):
                 continue
-            computed_taxes = self._compute_taxes(invoice)
+            computed_taxes = invoice._compute_taxes()
             if not invoice.taxes:
                 for tax in computed_taxes.values():
-                    tax_obj.create(tax)
+                    Tax.create(tax)
             else:
                 tax_keys = []
                 for tax in invoice.taxes:
                     if tax.manual:
                         continue
-                    key = (tax.base_code.id, tax.base_sign,
-                            tax.tax_code.id, tax.tax_sign,
-                            tax.account.id, tax.tax.id)
+                    base_code_id = tax.base_code.id if tax.base_code else None
+                    tax_code_id = tax.tax_code.id if tax.tax_code else None
+                    tax_id = tax.tax.id if tax.tax else None
+                    key = (base_code_id, tax.base_sign,
+                            tax_code_id, tax.tax_sign,
+                            tax.account.id, tax_id)
                     if (not key in computed_taxes) or (key in tax_keys):
                         if exception:
-                            self.raise_user_error('missing_tax_line')
-                        tax_obj.delete(tax.id)
+                            cls.raise_user_error('missing_tax_line')
+                        Tax.delete([tax])
                         continue
                     tax_keys.append(key)
-                    if not currency_obj.is_zero(invoice.currency,
+                    if not invoice.currency.is_zero(
                             computed_taxes[key]['base'] - tax.base):
                         if exception:
-                            self.raise_user_error('diff_tax_line')
-                        tax_obj.write(tax.id, computed_taxes[key])
+                            cls.raise_user_error('diff_tax_line')
+                        Tax.write([tax], computed_taxes[key])
                 for key in computed_taxes:
                     if not key in tax_keys:
                         if exception:
-                            self.raise_user_error('missing_tax_line')
-                        tax_obj.create(computed_taxes[key])
-        return True
+                            cls.raise_user_error('missing_tax_line')
+                        Tax.create(computed_taxes[key])
 
-    def _get_move_line_invoice_line(self, invoice):
+    def _get_move_line_invoice_line(self):
         '''
         Return list of move line values for each invoice lines
         '''
-        line_obj = Pool().get('account.invoice.line')
         res = []
-        for line in invoice.lines:
-            val = line_obj.get_move_line(line)
+        for line in self.lines:
+            val = line.get_move_line()
             if val:
                 res.extend(val)
         return res
 
-    def _get_move_line_invoice_tax(self, invoice):
+    def _get_move_line_invoice_tax(self):
         '''
         Return list of move line values for each invoice taxes
         '''
-        tax_obj = Pool().get('account.invoice.tax')
         res = []
-        for tax in invoice.taxes:
-            val = tax_obj.get_move_line(tax)
+        for tax in self.taxes:
+            val = tax.get_move_line()
             if val:
                 res.extend(val)
         return res
 
-    def _get_move_line(self, invoice, date, amount):
+    def _get_move_line(self, date, amount):
         '''
         Return move line
         '''
-        currency_obj = Pool().get('currency.currency')
+        Currency = Pool().get('currency.currency')
         res = {}
-        if invoice.currency.id != invoice.company.currency.id:
-            with Transaction().set_context(date=invoice.currency_date):
-                res['amount_second_currency'] = currency_obj.compute(
-                    invoice.company.currency.id, amount, invoice.currency.id)
+        if self.currency.id != self.company.currency.id:
+            with Transaction().set_context(date=self.currency_date):
+                res['amount_second_currency'] = Currency.compute(
+                    self.company.currency.id, amount, self.currency.id)
             res['amount_second_currency'] = abs(res['amount_second_currency'])
-            res['second_currency'] = invoice.currency.id
+            res['second_currency'] = self.currency.id
         else:
             res['amount_second_currency'] = Decimal('0.0')
             res['second_currency'] = None
@@ -847,29 +795,27 @@
         else:
             res['debit'] = - amount
             res['credit'] = Decimal('0.0')
-        res['account'] = invoice.account.id
+        res['account'] = self.account.id
         res['maturity_date'] = date
-        res['reference'] = invoice.reference
-        res['name'] = invoice.number
-        res['party'] = invoice.party.id
+        res['reference'] = self.reference
+        res['name'] = self.number
+        res['party'] = self.party.id
         return res
 
-    def create_move(self, invoice):
+    def create_move(self):
         '''
-        Create account move for the invoice and return the created move id
+        Create account move for the invoice and return the created move
         '''
         pool = Pool()
-        payment_term_obj = pool.get('account.invoice.payment_term')
-        currency_obj = pool.get('currency.currency')
-        move_obj = pool.get('account.move')
-        period_obj = pool.get('account.period')
-        date_obj = pool.get('ir.date')
+        Move = pool.get('account.move')
+        Period = pool.get('account.period')
+        Date = pool.get('ir.date')
 
-        if invoice.move:
+        if self.move:
             return True
-        self.update_taxes([invoice.id], exception=True)
-        move_lines = self._get_move_line_invoice_line(invoice)
-        move_lines += self._get_move_line_invoice_tax(invoice)
+        self.update_taxes([self], exception=True)
+        move_lines = self._get_move_line_invoice_line()
+        move_lines += self._get_move_line_invoice_tax()
 
         total = Decimal('0.0')
         total_currency = Decimal('0.0')
@@ -877,130 +823,116 @@
             total += line['debit'] - line['credit']
             total_currency += line['amount_second_currency']
 
-        term_lines = payment_term_obj.compute(total, invoice.company.currency,
-                invoice.payment_term, invoice.invoice_date)
+        term_lines = self.payment_term.compute(total, self.company.currency,
+            self.invoice_date)
         remainder_total_currency = total_currency
         if not term_lines:
-            term_lines = [(date_obj.today(), total)]
+            term_lines = [(Date.today(), total)]
         for date, amount in term_lines:
-            val = self._get_move_line(invoice, date, amount)
+            val = self._get_move_line(date, amount)
             remainder_total_currency -= val['amount_second_currency']
             move_lines.append(val)
-        if not currency_obj.is_zero(invoice.currency,
-                remainder_total_currency):
+        if not self.currency.is_zero(remainder_total_currency):
             move_lines[-1]['amount_second_currency'] += \
                 remainder_total_currency
 
-        accounting_date = invoice.accounting_date or invoice.invoice_date
-        period_id = period_obj.find(invoice.company.id, date=accounting_date)
+        accounting_date = self.accounting_date or self.invoice_date
+        period_id = Period.find(self.company.id, date=accounting_date)
 
-        move_id = move_obj.create({
-            'journal': invoice.journal.id,
+        move = Move.create({
+            'journal': self.journal.id,
             'period': period_id,
             'date': accounting_date,
             'lines': [('create', x) for x in move_lines],
             })
-        self.write(invoice.id, {
-            'move': move_id,
-            })
-        move_obj.post(move_id)
-        return move_id
+        self.write([self], {
+                'move': move.id,
+                })
+        Move.post([move])
+        return move
 
-    def set_number(self, invoice):
+    def set_number(self):
         '''
         Set number to the invoice
         '''
         pool = Pool()
-        period_obj = pool.get('account.period')
-        sequence_obj = pool.get('ir.sequence.strict')
-        date_obj = pool.get('ir.date')
+        Period = pool.get('account.period')
+        Sequence = pool.get('ir.sequence.strict')
+        Date = pool.get('ir.date')
 
-        if invoice.number:
+        if self.number:
             return
 
         test_state = True
-        if invoice.type in ('in_invoice', 'in_credit_note'):
+        if self.type in ('in_invoice', 'in_credit_note'):
             test_state = False
 
-        period_id = period_obj.find(invoice.company.id,
-                date=invoice.invoice_date, test_state=test_state)
-        period = period_obj.browse(period_id)
-        sequence_id = period[invoice.type + '_sequence'].id
+        period_id = Period.find(self.company.id,
+            date=self.invoice_date, test_state=test_state)
+        period = Period(period_id)
+        sequence_id = getattr(period, self.type + '_sequence').id
         if not sequence_id:
             self.raise_user_error('no_invoice_sequence')
         with Transaction().set_context(
-                date=invoice.invoice_date or date_obj.today()):
-            number = sequence_obj.get_id(sequence_id)
+                date=self.invoice_date or Date.today()):
+            number = Sequence.get_id(sequence_id)
             vals = {'number': number}
-            if not invoice.invoice_date:
+            if not self.invoice_date:
                 vals['invoice_date'] = Transaction().context['date']
-        self.write(invoice.id, vals)
+        self.write([self], vals)
 
-    def check_modify(self, ids):
+    @classmethod
+    def check_modify(cls, invoices):
         '''
         Check if the invoices can be modified
         '''
-        for invoice in self.browse(ids):
+        for invoice in invoices:
             if invoice.state in ('open', 'paid'):
-                self.raise_user_error('modify_invoice')
-        return
+                cls.raise_user_error('modify_invoice')
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        res = {}
-        for invoice in self.browse(ids):
-            res[invoice.id] = invoice.number or unicode(invoice.id) + \
-                    (invoice.reference and (' ' + invoice.reference) or '') + \
-                    ' ' + invoice.party.rec_name
-        return res
+    def get_rec_name(self, name):
+        return (self.number or unicode(self.id)
+            + (self.reference and (' ' + self.reference) or '')
+            + ' ' + self.party.rec_name)
 
-    def search_rec_name(self, name, clause):
-        ids = self.search(['OR',
-            ('number',) + clause[1:],
-            ('reference',) + clause[1:],
-            ], order=[])
-        if ids:
-            return [('id', 'in', ids)]
+    @classmethod
+    def search_rec_name(cls, name, clause):
+        invoices = cls.search(['OR',
+                ('number',) + clause[1:],
+                ('reference',) + clause[1:],
+                ], order=[])
+        if invoices:
+            return [('id', 'in', [i.id for i in invoices])]
         return [('party',) + clause[1:]]
 
-    def delete(self, ids):
-        if not ids:
-            return True
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        self.check_modify(ids)
+    @classmethod
+    def delete(cls, invoices):
+        cls.check_modify(invoices)
         # Cancel before delete
-        self.cancel(ids)
-        for invoice in self.browse(ids):
+        cls.cancel(invoices)
+        for invoice in invoices:
             if invoice.state != 'cancel':
-                self.raise_user_error('delete_cancel', invoice.rec_name)
-        return super(Invoice, self).delete(ids)
+                cls.raise_user_error('delete_cancel', invoice.rec_name)
+        super(Invoice, cls).delete(invoices)
 
-    def write(self, ids, vals):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def write(cls, invoices, vals):
         keys = vals.keys()
-        for key in self._check_modify_exclude:
+        for key in cls._check_modify_exclude:
             if key in keys:
                 keys.remove(key)
         if len(keys):
-            self.check_modify(ids)
-        update_tax_ids = [x.id for x in self.browse(ids) if x.state == 'draft']
-        res = super(Invoice, self).write(ids, vals)
-        if update_tax_ids:
-            self.update_taxes(update_tax_ids)
-        return res
+            cls.check_modify(invoices)
+        update_tax = [i for i in invoices if i.state == 'draft']
+        super(Invoice, cls).write(invoices, vals)
+        if update_tax:
+            cls.update_taxes(update_tax)
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, invoices, default=None):
         pool = Pool()
-        line_obj = pool.get('account.invoice.line')
-        tax_obj = pool.get('account.invoice.tax')
-
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
+        Line = pool.get('account.invoice.line')
+        Tax = pool.get('account.invoice.tax')
 
         if default is None:
             default = {}
